﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Northwind.Common
{
    public partial class PointOrbMarker : UserControl
    {
        public PointOrbMarker()
        {
            InitializeComponent();
        }

        public PointOrbMarker(Color color, Color stroke, string labelData)
        {
            // Required to initialize variables
            InitializeComponent();


            Orb.Fill = new SolidColorBrush(color);
            Orb.Stroke = new SolidColorBrush(stroke);

            OuterRing.Stroke = new SolidColorBrush(color);

            GradientBrush topReflectBrush = (GradientBrush)TopReflect.Fill;
            GradientBrush bottomReflectBrush = (GradientBrush)BottomReflect.Fill;

            Color modColor = Color.FromArgb(0, color.R, color.G, color.B);

            //Set the color, A needs to be 0
            topReflectBrush.GradientStops[1].Color = modColor;
            bottomReflectBrush.GradientStops[1].Color = modColor;

            LabelDataTextBlock.Text = labelData;
        }
    }
}
