﻿using System;
using GalaSoft.MvvmLight.Messaging;

namespace Northwind.Common
{
    public class GlobalAppCommands
    {
        // This event is fired in the Bootstrapper when all modules are loaded.
        public static class AppModulesLoaded
        {
            public static void Send(AppModulesLoadedEvent evt)
            {
                Messenger.Default.Send<AppModulesLoadedEvent>(evt);
            }

            public static void Register(object recipient, Action<AppModulesLoadedEvent> action)
            {
                Messenger.Default.Register<AppModulesLoadedEvent>(recipient, action);
            }
        }

        public static class RaiseErrorMessage
        {
            public static void Send(AppRaiseErrorEvent evt)
            {
                Messenger.Default.Send<AppRaiseErrorEvent>(evt);
            }

            public static void Register(object recipient, Action<AppRaiseErrorEvent> action)
            {
                Messenger.Default.Register<AppRaiseErrorEvent>(recipient, action);
            }
        }
        
        // Used to set the status and content of the MainPages BusyIndicator
        public static class SetAppIsBusyStatus
        {
            public static void Send(SetAppIsBusyStatusEvent evt)
            {
                Messenger.Default.Send<SetAppIsBusyStatusEvent>(evt);
            }

            public static void Register(object recipient, Action<SetAppIsBusyStatusEvent> action)
            {
                Messenger.Default.Register<SetAppIsBusyStatusEvent>(recipient, action);
            }
        }

        public static class SetAppRootTemplate
        {
            public static void Send(SetAppRootTemplateEvent evt)
            {
                Messenger.Default.Send<SetAppRootTemplateEvent>(evt);
            }

            public static void Register(object recipient, Action<SetAppRootTemplateEvent> action)
            {
                Messenger.Default.Register<SetAppRootTemplateEvent>(recipient, action);
            }
        }


    }
}
