﻿using System;
using System.Linq;
using MVVM.Framework;
using Northwind.Common.NwSvc;

namespace Northwind.Common
{

    internal static class CustomerModelAssembler<T> where T : CustomerModel, new()
    {
        internal static SmartObservableCollection<T> AssembleContracts(Customer[] froms)
        {
            SmartObservableCollection<T> tos = new SmartObservableCollection<T>();

            foreach (Customer from in froms)
            {
                tos.Add(AssembleContract(from));
            }

            Array.Clear(froms, 0, froms.Length);

            return (SmartObservableCollection<T>)tos;
        }

        internal static T AssembleContract(Customer from)
        {
            T to = new T();

            to.CustomerId.DataValue = from.CustomerId;
            to.CompanyName.DataValue = from.CompanyName;
            to.ContactName.DataValue = from.ContactName;
            to.ContactTitle.DataValue = from.ContactTitle;
            to.Address.DataValue = from.Address;
            to.City.DataValue = from.City;
            to.Region.DataValue = from.Region;
            to.PostalCode.DataValue = from.PostalCode;
            to.Country.DataValue = from.Country;
            to.Phone.DataValue = from.Phone;
            to.Fax.DataValue = from.Fax;

            return to;
        }
    }
}
