﻿using System;
using System.Linq;
using Northwind.Common.NwSvc;
using MVVM.Framework;

namespace Northwind.Common
{

    public class OrderDetailModelAssembler<T> where T : OrderDetailModel, new()
    {
        internal static SmartObservableCollection<T> AssembleContracts(OrderDetail[] froms)
        {
            SmartObservableCollection<T> tos = new SmartObservableCollection<T>();

            foreach (OrderDetail from in froms)
            {
                tos.Add(AssembleContract(from));
            }

            Array.Clear(froms, 0, froms.Length);

            return (SmartObservableCollection<T>)tos;
        }

        internal static T AssembleContract(OrderDetail from)
        {
            T to = new T();

            to.OrderId.DataValue = from.OrderId;
            to.ProductId.DataValue = from.ProductId;
            to.UnitPrice.DataValue = from.UnitPrice;
            to.Quantity.DataValue = from.Quantity;
            to.Discount.DataValue = from.Discount;

            if (from.Product != null)
            {
                to.Product = ProductModelAssembler<ProductModel>.AssembleContract(from.Product);
            }

            return to;
        }

    }
}
