﻿using System;
using System.Linq;
using MVVM.Framework;
using Northwind.Common.NwSvc;

namespace Northwind.Common
{
 
    public class OrderStatusModelAssembler<T> where T : OrderStatusModel, new()
    {
        internal static SmartObservableCollection<T> AssembleContracts(OrderStatus[] froms)
        {
            SmartObservableCollection<T> tos = new SmartObservableCollection<T>();

            foreach (OrderStatus from in froms)
            {
                tos.Add(AssembleContract(from));
            }

            return (SmartObservableCollection<T>)tos;
        }

        internal static T AssembleContract(OrderStatus from)
        {
            T to = new T();

            to.OrderStatusId.DataValue = from.OrderStatusId;
            to.OrderStatusValue.DataValue = from.OrderStatusValue;

            return to;
        }
    }
}
