﻿using System;
using System.Linq;
using Northwind.Common.NwSvc;
using MVVM.Framework;

namespace Northwind.Common
{

    public class ProductModelAssembler<T> where T : ProductModel, new()
    {
        internal static SmartObservableCollection<T> AssembleContracts(Product[] froms)
        {
            SmartObservableCollection<T> tos = new SmartObservableCollection<T>();

            foreach (Product from in froms)
            {
                tos.Add(AssembleContract(from));
            }

            Array.Clear(froms, 0, froms.Length);

            return (SmartObservableCollection<T>)tos;
        }

        internal static T AssembleContract(Product from)
        {
            T to = new T();

            to.ProductId.DataValue = from.ProductId;
            to.ProductName.DataValue = from.ProductName;
            to.SupplierId.DataValue = from.SupplierId;
            to.CategoryId.DataValue = from.CategoryId;
            to.QuantityPerUnit.DataValue = from.QuantityPerUnit;
            to.UnitPrice.DataValue = from.UnitPrice;
            to.UnitsInStock.DataValue = from.UnitsInStock;
            to.UnitsOnOrder.DataValue = from.UnitsOnOrder;
            to.ReorderLevel.DataValue = from.ReorderLevel;
            to.Discontinued.DataValue = from.Discontinued;

            return to;
        }
    }
}
