﻿using System;
using System.Linq;
using Northwind.Common.NwSvc;
using MVVM.Framework;

namespace Northwind.Common
{

    internal static class ShipperModelAssembler<T> where T : ShipperModel, new()
    {
        internal static SmartObservableCollection<T> AssembleContracts(Shipper[] froms)
        {
            SmartObservableCollection<T> tos = new SmartObservableCollection<T>();

            foreach (Shipper from in froms)
            {
                tos.Add(AssembleContract(from));
            }

            Array.Clear(froms, 0, froms.Length);

            return (SmartObservableCollection<T>)tos;
        }

        internal static T AssembleContract(Shipper from)
        {
            T to = new T();

            to.ShipperId.DataValue = from.ShipperId;
            to.CompanyName.DataValue = from.CompanyName;
            to.Phone.DataValue = from.Phone;

            return to;
        }
    }
}
