﻿using System;
using System.Linq;
using MVVM.Framework;
using System.ComponentModel;


namespace Northwind.Common
{
    public class OrderStatusModel : BaseEditableValidatingModel
    {
        #region ctor

        public OrderStatusModel()
        {
            OrderStatusId = new DataWrapper<short?>(this, _orderStatusIdChangeArgs);
            OrderStatusValue = new DataWrapper<string>(this, _orderStatusValueChangeArgs);

            CachedListOfDataWrappers = DataWrapperHelper.GetWrapperProperties<OrderStatusModel>(this).ToList();
        }

        #endregion


        #region Private Member Variables

        private DataWrapper<short?> _orderStatusId;
        private DataWrapper<string> _orderStatusValue;

        #endregion

        #region Public Properties

        static PropertyChangedEventArgs _orderStatusIdChangeArgs =
        ObservableHelper.CreateArgs<OrderStatusModel>(x => x.OrderStatusId);

        public DataWrapper<short?> OrderStatusId
        {
            get { return _orderStatusId; }
            private set
            {
                _orderStatusId = value;
                NotifyPropertyChanged(_orderStatusIdChangeArgs);
            }
        }

        static PropertyChangedEventArgs _orderStatusValueChangeArgs =
        ObservableHelper.CreateArgs<OrderStatusModel>(x => x.OrderStatusValue);

        public DataWrapper<string> OrderStatusValue
        {
            get { return _orderStatusValue; }
            private set
            {
                _orderStatusValue = value;
                NotifyPropertyChanged(_orderStatusValueChangeArgs);
            }
        }

        #endregion


       
    }
}
