﻿using System;
using System.Linq;
using MVVM.Framework;
using System.ComponentModel;

namespace Northwind.Common
{
    public class ShipperModel : BaseEditableValidatingModel
    {
        #region ctor

        public ShipperModel()
        {
            ShipperId = new DataWrapper<int?>(this, _shipperIdChangeArgs);
            CompanyName = new DataWrapper<string>(this, _companyNameChangeArgs);
            Phone = new DataWrapper<string>(this, _phoneChangeArgs);
            CachedListOfDataWrappers = DataWrapperHelper.GetWrapperProperties<ShipperModel>(this).ToList();
        }

        #endregion


        #region Private Member Variables

        private DataWrapper<int?> _shipperId;
        private DataWrapper<string> _companyName;
        private DataWrapper<string> _phone;

        #endregion

        #region Public Properties

        static PropertyChangedEventArgs _shipperIdChangeArgs =
        ObservableHelper.CreateArgs<ShipperModel>(x => x.ShipperId);

        public DataWrapper<int?> ShipperId
        {
            get { return _shipperId; }
            private set
            {
                _shipperId = value;
                NotifyPropertyChanged(_shipperIdChangeArgs);
            }
        }

        static PropertyChangedEventArgs _companyNameChangeArgs =
        ObservableHelper.CreateArgs<ShipperModel>(x => x.CompanyName);

        public DataWrapper<string> CompanyName
        {
            get { return _companyName; }
            private set
            {
                _companyName = value;
                NotifyPropertyChanged(_companyNameChangeArgs);
            }
        }

        static PropertyChangedEventArgs _phoneChangeArgs =
        ObservableHelper.CreateArgs<ShipperModel>(x => x.Phone);

        public DataWrapper<string> Phone
        {
            get { return _phone; }
            private set
            {
                _phone = value;
                NotifyPropertyChanged(_phoneChangeArgs);
            }
        }

        #endregion


       

    }
}
