﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Map;

namespace Northwind.Modules.Orders
{
    // We need to have a way for the OrderViewModel to notify listeneres when the map collection has changed.
    // The reason is because map controls contain functionality in their code to recalculate their zoom
    // based on markers they are bound too.  For now this functionality only exists directly in the Map Control
    // So we use global messaging to fire an event and pass back a LocationRect the Telerik MapControl needs 
    // To calculate Zoom & Center values
    public class CustomerMapOrdersChangedEvent
    {
        public CustomerMapOrdersChangedEvent(LocationRect obj, int defaultZoomLevel)
        {
            BestView = obj;
            DefaultZoomLevel = defaultZoomLevel;
        }
        
        public LocationRect BestView { get; private set; }
        public int DefaultZoomLevel { get; private set; }
    }
}
