﻿using System;
using System.Linq;
using System.ComponentModel.Composition;

namespace Northwind.Modules.Orders
{
    public class OrderViewModelLocator
    {
        #region MapOrderViewModel

        private static MapOrderViewModel _mapOrderViewModel;

        /// <summary>
        /// Gets the MapOrderViewModel property.
        /// </summary>

        public static MapOrderViewModel MapOrderViewModelStatic
        {
            get
            {
                return _mapOrderViewModel;
            }
            set
            {
                _mapOrderViewModel = value;
            }
        }

        /// <summary>
        /// Gets the AlertAlarmViewModel property.
        /// </summary>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance",
            "CA1822:MarkMembersAsStatic",
            Justification = "This non-static member is needed for data binding purposes.")]
        [Import(typeof(MapOrderViewModel), AllowDefault = false, AllowRecomposition = true)]
        public MapOrderViewModel MapOrderViewModel
        {
            get
            {
                if (_mapOrderViewModel == null)
                    CompositionInitializer.SatisfyImports(this);

                return MapOrderViewModelStatic;
            }
            set { _mapOrderViewModel = value; }
        }

        /// <summary>
        /// Provides a deterministic way to delete the AlertAlarm property.
        /// </summary>           
        public static void ClearMapOrderViewModel()
        {
            // _alertAlarm.Dispose();
            _mapOrderViewModel = null;
        }

        #endregion

        #region OrderViewModel

        private static OrderViewModel _orderViewModel;

        /// <summary>
        /// Gets the NorthwindViewModel property.
        /// </summary>

        public static OrderViewModel OrderViewModelStatic
        {
            get
            {
                return _orderViewModel;
            }
            set
            {
                _orderViewModel = value;
            }
        }

        /// <summary>
        /// Gets the AlertAlarmViewModel property.
        /// </summary>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance",
            "CA1822:MarkMembersAsStatic",
            Justification = "This non-static member is needed for data binding purposes.")]
        [Import(typeof(IOrderViewModel), AllowDefault = false, AllowRecomposition = true)]
        public OrderViewModel OrderViewModel
        {
            get
            {
                if (_orderViewModel == null)
                    CompositionInitializer.SatisfyImports(this);

                return OrderViewModelStatic;
            }
            set { _orderViewModel = value; }
        }

        /// <summary>
        /// Provides a deterministic way to delete the AlertAlarm property.
        /// </summary>           
        public static void ClearOrderViewModel()
        {
            // _alertAlarm.Dispose();
            _orderViewModel = null;
        }

        #endregion

        public static void Dispose()
        {
            ClearOrderViewModel();

        }
    }
}
