﻿using System;
using MVVM.Framework;
using GalaSoft.MvvmLight.Command;
using System.Collections.ObjectModel;
using System.ComponentModel.Composition;
using Northwind.Common;
using GalaSoft.MvvmLight;

namespace Northwind.Modules.Orders
{
    [Export(typeof(IRootToolBarVM))]
    public class RootToolBarVM : ViewModelBase, IRootToolBarVM
    {
        // Image, command, tool tip
        #region Private Fields
        
        private string _imageURI;
        private string _toolTip;
        private ObservableCollection<RootToolBarVM> _qATBButtons;

        public ObservableCollection<RootToolBarVM> QATBButtons
        {
            get { return _qATBButtons; }
            set
            {
                if (_qATBButtons != value)
                {
                    _qATBButtons = value;
                    RaisePropertyChanged(ReflectionUtility.GetPropertyName(() => QATBButtons));
                }
            }
        }

        #endregion

        public RelayCommand ButtonClickCommand { get; private set; }

        #region Public Property

        public string ImageURI
        {
            get { return _imageURI; }
            set
            {
                if (_imageURI != value)
                {
                    _imageURI = value;
                    RaisePropertyChanged(ReflectionUtility.GetPropertyName(() => ImageURI));
                }
            }
        }

        public IOrderController NorthwindController { get; set; }

        [ImportMany(typeof(IPopupController), AllowRecomposition=true)]
        public IPopupController[] PopupController { get; set; }

        public string ToolTip
        {
            get { return _toolTip; }
            set
            {
                if (_toolTip != value)
                {
                    _toolTip = value;
                    RaisePropertyChanged(ReflectionUtility.GetPropertyName(() => ToolTip));
                }
            }
        }

        #endregion

        #region ctor
        
        public RootToolBarVM()
        {
            _qATBButtons = new ObservableCollection<RootToolBarVM>();
        }
        
        #endregion

        #region Private Methods

        private void PopulateButtons()
        {

        }

        #endregion

        #region IRootToolBarVM Members

        public void ClearQATBButtons()
        {
            QATBButtons.Clear();
        }

        public void PopulateQATBButtons()
        {
            RootToolBarVM _vm1 = new RootToolBarVM();
            _vm1.ToolTip = "Show Popup 1";
            _vm1.ImageURI = "Northwind.Commond;component/Assets/Images/Editor.png";
            _vm1.ButtonClickCommand = new RelayCommand(() =>
                {
                    PopupController[0].ShowMainPopup(new MapOrderView());
                });

            QATBButtons.Add(_vm1);
        }

        #endregion
    }
}
