﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Controls;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Messaging;
using System.ComponentModel.Composition;
using Northwind.Common;
using System.Diagnostics;
using MVVM.Framework;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Controls;
using System.Windows.Data;


namespace Northwind.Modules.Orders
{
    [Export]
    public partial class OrderView : UserControl, ICleanup
    {
        public OrderView()
        {
            InitializeComponent();
            //OrderViewModelLocator _nw = new OrderViewModelLocator();
            
        }

        [Import(typeof(IOrderViewModel))]
        public OrderViewModel ViewModel
        {
            get
            {
                return this.DataContext as OrderViewModel;
            }
            set
            {
                this.DataContext = value;
            }
        }

        #region ICleanup Members

        public void Cleanup()
        {
            //call cleanup on it's ViewModel
            ((ICleanup)this.DataContext).Cleanup();

            // Cleanup itself
            Messenger.Default.Unregister(this);
        }

        #endregion

        private void RGridOrderDetails_DataLoading(object sender, Telerik.Windows.Controls.GridView.GridViewDataLoadingEventArgs e)
        {
            SmartObservableCollection<OrderDetailModel> _objs = e.ItemsSource as SmartObservableCollection<OrderDetailModel>;

            GridViewDataControl _dataControl = (GridViewDataControl)sender;

            // kkf not proud of this but time and design of database and requirements dictate doing this.  Load is hardcoded on the 
            // Server side for BOL records
            //OrderStatusModel _status = _objs.ElementAt(0).;
            //_objs.ElementAt(0).Product.ProductName.DataValue
            if (_dataControl.ParentRow != null)
            {                
                GridViewDataColumn _column = new GridViewDataColumn();
                _column.Header = "Product Id";
                _column.DataMemberBinding = new Binding("ProductId.DataValue");
                _dataControl.Columns.Add(_column);

                _column = new GridViewDataColumn();
                _column.Header = "Product Name";
                _column.DataMemberBinding = new Binding("Product.ProductName.DataValue");
                _dataControl.Columns.Add(_column);

                _column = new GridViewDataColumn();
                _column.Header = "Unit Price";
                _column.DataMemberBinding = new Binding("UnitPrice.DataValue");
                _dataControl.Columns.Add(_column);

                _column = new GridViewDataColumn();
                _column.Header = "Quantity";
                _column.DataMemberBinding = new Binding("Quantity.DataValue");
                _dataControl.Columns.Add(_column);

                _column = new GridViewDataColumn();
                _column.Header = "Discount";
                _column.DataMemberBinding = new Binding("Discount.DataValue");
                _dataControl.Columns.Add(_column);

                //_column = new GridViewDataColumn();
                //_column.Header = "Total";
                
                //_column.DataMemberBinding = new Binding("Discount.DataValue");
                //_dataControl.Columns.Add(_column);
            }
        }

    }
}
