﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Windows.Controls;
using Microsoft.Practices.Prism.Regions;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Messaging;

namespace NorthwindSL
{
    [Export]
    public partial class Shell : UserControl, ICleanup

    {
        public Shell()
        {
            InitializeComponent();
            
        }

        [Import(typeof(IShellViewModel))]
        public IShellViewModel ViewModel
        {
            set { this.DataContext = value; }
        }


        #region ICleanup Members

        public void Cleanup()
        {
            //call cleanup on it's ViewModel
            ((ICleanup)this.DataContext).Cleanup();

            // Cleanup itself
            Messenger.Default.Unregister(this);
        }

        #endregion
    }
}
